/*
 * NTOFException.h
 *  General exception object for NTOF
 *  Created on: Oct 13, 2014
 *      Author: mdonze
 */

#ifndef NTOFEXCEPTION_H_
#define NTOFEXCEPTION_H_

#include <string>

namespace ntof {
/**
 * Represents an exception generated by NTOF
 */
class NTOFException : public std::exception
{
public:
    /**
     * Constructs this
     * @param Msg Error message
     * @param file Name of the file where the exception is thrown (__FILE__)
     * @param Line Line of code doing the error (__LINE__)
     */
    NTOFException(const std::string &Msg,
                  const std::string &file,
                  int Line,
                  int error = 0);

    /**
     * Construct this
     * @param Msg Error message
     * @param file Name of the file where the exception is thrown (__FILE__)
     * @param Line Line of code doing the error (__LINE__)
     * @param error Error code
     */
    NTOFException(const char *Msg,
                  const std::string &file,
                  int Line,
                  int error = 0);

    /**
     * Empty constructor
     */
    NTOFException();

    /**
     * Destroy this
     */
    virtual ~NTOFException() = default;

    /**
     * Overload of std::exception
     * @return Error message
     */
    virtual const char *what() const noexcept;

    /**
     * Gets the error message
     * @return The error message
     */
    inline const char *getMessage() const noexcept { return msg.c_str(); }

    /**
     * Gets the error code
     * @return
     */
    inline int getErrorCode() const noexcept { return errorCode; }

    /**
     * Gets the source file
     * @return Source file name
     */
    inline const std::string &getFile() const noexcept { return file_; }

    /**
     * Gets the line in source file
     * @return the line in source file
     */
    inline int getLine() const noexcept { return line; }

protected:
    mutable std::string what_; //!< Complete error message
    std::string msg;           //!< Error message
    std::string file_;         //!< Source file where the exception is throw
    int line;                  //!< Line of the error
    int errorCode;             //!< Error code
};
} // namespace ntof

#endif /* NTOFEXCEPTION_H_ */
